<?php

add_action( 'init', 'create_keyword_post_types' );
function create_keyword_post_types() {
	 $labels = array(
		'name' => _x( 'Keyword Categories', 'taxonomy general name' ),
		'singular_name' => _x( 'Keyword Category', 'taxonomy singular name' ),
		'search_items' =>  __( 'Search Keyword Categories' ),
		'all_items' => __( 'All Keyword Categories' ),
		'parent_item' => __( 'Parent Keyword Category' ),
		'parent_item_colon' => __( 'Parent Keyword Category:' ),
		'edit_item' => __( 'Edit Keyword Category' ), 
		'update_item' => __( 'Update Keyword Category' ),
		'add_new_item' => __( 'Add New Keyword Category' ),
		'new_item_name' => __( 'New Keyword Category Name' ),
 		
  ); 	
  
 register_taxonomy('keyword_category',array('keyword_post'), array(
		'hierarchical' => true,
		'labels' => $labels,
		'show_ui' => true,
		'query_var' => true,
		'rewrite' => array( 'slug' => 'keyword-category' ),
  ));
	register_post_type( 'keyword_post',
		array(
				'labels' 		=> array(
				'name' 			=> __( 'Keywords' ),
				'singular_name' => __( 'Keyword' ),
				'add_new' 		=> _x('Add New Keyword', 'Keyword'),
    			'add_new_item' 	=> __('Add New Keyword'),
				'edit_item'		=>	__( 'Edit Keyword'),
				 'view_item' 	=> __('View Keyword'),
				'add_new_item'	=>	__( 'Add Keyword')

			),
			'public' => true,
			'menu_position' => 10,
			'menu_icon' => admin_url('images/generic.png'),
			'show_ui' => true,
			'capability_type' => 'post',
			'rewrite' => array( 'slug' => 'keyword', 'with_front' => false ),
			'taxonomies' => array( 'Keywords '),
			'supports' => array(
			 'title',
	  'editor',
	  'excerpt',
	  'revisions',
	  'thumbnail',
	  'custom-fields',
	  'author',
	  )
		)
	);
  
  
}	




