<?php

add_action( 'init', 'create_notification_post_types' );
function create_notification_post_types() {
	 $labels = array(
		'name' 					=>	_x( 'Notification Categories', 'taxonomy general name' ),
		'singular_name' 		=>	_x( 'Notification Category', 'taxonomy singular name' ),
		'search_items'			=>	__( 'Search Notification Categories' ),
		'all_items'				=>	__( 'All Notification Categories' ),
		'parent_item'			=>	__( 'Parent Notification Category' ),
		'parent_item_colon' 	=>	__( 'Parent Notification Category:' ),
		'edit_item'				=>	__( 'Edit Notification Category' ), 
		'update_item'			=>	__( 'Update Notification Category' ),
		'add_new_item'			=>	__( 'Add New Notification Category' ),
		'new_item_name'			=>	__( 'New Notification Category Name' ),
 		
  ); 	
  
 register_taxonomy('notification_category',array('notification_post'), array(
		'hierarchical' => true,
		'labels' => $labels,
		'show_ui' => true,
		'query_var' => true,
		'rewrite' => array( 'slug' => 'notification-category' ),
  ));
	register_post_type( 'notification_post',
		array(
				'labels' 		=> array(
				'name' 			=> __( 'Notifications' ),
				'singular_name' => __( 'Notification' ),
				'add_new' 		=> _x('Add New Notification', 'Notification'),
    			'add_new_item' 	=> __('Add New Notification'),
				'edit_item'		=>	__( 'Edit Notification'),
				 'view_item' 	=> __('View Notification'),
				'add_new_item'	=>	__( 'Add Notification')

			),
			'public' => true,
			'menu_position' => 10,
			'menu_icon' => admin_url('images/generic.png'),
			'show_ui' => true,
			'capability_type' => 'post',
			'rewrite' => array( 'slug' => 'notification', 'with_front' => false ),
			'taxonomies' => array( 'Notifications '),
			'supports' => array(
			 'title',
	  'editor',
	  'excerpt',
	  'revisions',
	  'thumbnail',
	  'custom-fields',
	  'author',
	  )
		)
	);
  
  
}	




