$(document).ready(function(){
	
	 $('#poll_form').validate({
         focusInvalid: false,
         ignore: "",
         rules: {
		 	poll_title: {
     			minlength	:	2,
     			maxlength	:	100,
                 required	:	true
             },
             
             poll_keyword: {
              	required	:	true
              },
              poll_response: {
             	maxlength	:	160,
             }
             
			}
        
     });
 
	
	
	$('.add-choice-btn').click(function(){
		choice_row_clone	=	$('.choice-row-clone').html();
		$('.choice-rows-list').append(choice_row_clone);
		var i = 1;
		$('.choice-rows-list .poll_choice_title').each(function(){
			p_c_t	=	'poll_choice_title_'+i;
			$(this).attr({'name':p_c_t, 'id':p_c_t});
			$('#'+p_c_t).addClass('required');
			i++;
		});	
		var i = 1;
		$('.choice-rows-list .poll_choice_vote_count').each(function(){
			p_c_v	=	'poll_choice_vote_count_'+i;
			$(this).attr({'name':p_c_v, 'id':p_c_v});
			$('#'+p_c_v).addClass('required');
			i++;
		});	
	});
	
	
	$(document).on('click','.delete-choice-btn',function(){
		$(this).parents('.choice-row').hide();
		$(this).parents('.choice-row').find('.poll_choice_title')		.attr({'name':'', 'id':''}).removeClass('required error');
		$(this).parents('.choice-row').find('.poll_choice_vote_count')	.attr({'name':'', 'id':''}).removeClass('required error');
		$(this).parents('.choice-row').find('.poll_choice_status')		.val(0);
	});
	
	$('.poll_start_date').datetimepicker({
    	format: 'DD/MM/YYYY'
    });
    
	$('.poll_end_date').datetimepicker({
    	format: 'DD/MM/YYYY',
        useCurrent: false 
    });
    
	$(".poll_start_date").on("dp.change", function (e) {
        $('.poll_end_date').data("DateTimePicker").minDate(e.date);
    });
    
	$(".poll_end_date").on("dp.change", function (e) {
        $('.poll_start_date').data("DateTimePicker").maxDate(e.date);
    });
	view_programs_table	=	$("#view_poll_table").DataTable({
		bSort: false,
	    responsive: true,
	   
	    aLengthMenu: [
	        [10, 25, 50, 100, -1],
	        [10, 25, 50, 100, "All"]
	    ],
		"dom": '<"top"iflp<"clear">>rt<"bottom"iflp<"clear">>',
		bFilter: false,
		"bLengthChange": false
	});
	
	 
	if(!$('.choice-rows-list .choice-row').size()){
		$('.add-choice-btn').trigger('click');
	}
	if($('.poll_keyword_hidden').size()){
		$('.poll_keyword option[value="'+$('.poll_keyword_hidden').val()+'"]').attr('selected','selected');
	}
	if($('#poll_active_hidden').size() && $('#poll_active_hidden').val() != ''){
		$('[name="poll_active"][value="'+$('#poll_active_hidden').val()+'"]').attr('checked','checked');
	}
	$(document).on('blur','.poll_choice_title,.poll_choice_vote_count',function(){
		update_poll_choice_json();
	});
	$('#poll_form').submit(function(){
		update_poll_choice_json();
	});
	
	$(document).on('click', '.delete_post_row_btn',  function(){

		
		var current_tr		=	$(this).parents('tr');
		var post_id			=	$('.row_id',current_tr).val();
		var row_title_td	=	$('.row_title_td',current_tr).text();
		var confirm_flag = confirm("Are you sure, Do you want to delete "+row_title_td+"?");
		if (confirm_flag == true) {
			var delete_ajax_url	=	get_template_directory_uri()+'/ajax-delete.php';
			$.ajax({
				  method: "POST",
				  url: delete_ajax_url,
				  data: {controller: 'poll', action: 'delete', id : post_id}
			})
			  .done(function( data ) {
				if(data){
			    	view_programs_table.row(current_tr).remove().draw( false );
					showSuccess("Deleted Successfully!");
			    }else{
			    	showSuccess('Please try again!');
			    }
			});
		} else {
		   
		}
		return false;
	});	
	
});

function update_poll_choice_json(){
	
	var choice_rows_list	=	$('.choice-rows-list');
	if($('.choice-row',choice_rows_list).size()){
		var poll_choice_arr	=	[];
		$('.choice-row',choice_rows_list).each(function(){
			choice_row	= $(this);
			var poll_choice	=	{};
			if($('.poll_choice_title',choice_row).val()	!= ''){
				poll_choice.poll_choice_id			=	$('.poll_choice_id'			,choice_row).val();
				poll_choice.poll_choice_title		=	$('.poll_choice_title'		,choice_row).val();
				poll_choice.poll_choice_vote_count	=	$('.poll_choice_vote_count'	,choice_row).val();
				poll_choice.poll_choice_status		=	$('.poll_choice_status'		,choice_row).val();
				
				poll_choice_arr.push(poll_choice);
			}
		});
		poll_choice_json	=	JSON.stringify(poll_choice_arr);
		$('#poll_choice_json').val(poll_choice_json);
	}
	
}