<?php
Class DS_Keyword_Model{
	public function save_keyword(DS_Keyword_SetGet $keyword_setget){
		global $wpdb;
		$table	=	$wpdb->prefix.'keyword';
		
		$keyword_id					=	$keyword_setget->getKeyword_id();
		
		$keyword_title				=	$keyword_setget->getKeyword_title();
		$keyword_response			=	$keyword_setget->getKeyword_response();
		$keyword_active				=	$keyword_setget->getKeyword_active();
		$keyword_admin_only			=	$keyword_setget->getKeyword_admin_only();
		$keyword_auto_replay		=	$keyword_setget->getKeyword_auto_replay();
		$keyword_start_date			=	$keyword_setget->getKeyword_start_date();
		$keyword_end_date			=	$keyword_setget->getKeyword_end_date();
		$keyword_smsuid				=	$keyword_setget->getKeyword_smsuid();
		
		$db_transaction_flag	=	true;
		$data	=	array( 
						'keyword_title' 			=>	$keyword_title,
						'keyword_response'			=>	$keyword_response,
						'keyword_active'			=>	$keyword_active,
						'keyword_admin_only'		=>	$keyword_admin_only,
						'keyword_auto_replay'		=>	$keyword_auto_replay,
						'keyword_start_date'		=>	$keyword_start_date,
						'keyword_end_date'			=>	$keyword_end_date,
						'keyword_smsuid'			=>	$keyword_smsuid,
						'is_special'			=>	$_POST['is_special'],
					);
					
		if($keyword_id){
			$where	=	array('keyword_id'	=> $keyword_id);
			$update_flag	=	$wpdb->update( $table,  $data , $where);
			if($update_flag	=== false){
				$keyword_id	=	false;			
			}
		}else{
			$insert_flag	=	$wpdb->insert( $table,  $data);
			if($insert_flag){
				$keyword_id	=	$wpdb->insert_id;	
			}else{
				$keyword_id	=	false;
			}
		}
		
		
		return $keyword_id;
	}
	
	public function get_keywords($type){
		
		global $wpdb;
		$keyword_list_arr	=	array();
		$table	=	$wpdb->prefix.'keyword';
		$where = '';
		if($type != ''){
			$where .= "AND (connected_type = '' OR connected_type = '$type')";
		}
		$keyWordsQuery = "SELECT
			
			keyword_id, keyword_title, keyword_smsuid, keyword_admin_only, keyword_auto_replay, 
			keyword_start_date, keyword_end_date, keyword_response, keyword_active, is_special
			
			FROM $table
			WHERE keyword_status = 1 $where";
		$keyword_list = $wpdb->get_results($keyWordsQuery);
			
		if($keyword_list){
			foreach ($keyword_list as $keyword){
				
				
				
				$keyword_id					=	$keyword->keyword_id;
				$keyword_title				=	$keyword->keyword_title;
				$keyword_response			=	$keyword->keyword_response;
				$keyword_active				=	$keyword->keyword_active;
				$keyword_admin_only			=	$keyword->keyword_admin_only;
				$keyword_auto_replay		=	$keyword->keyword_auto_replay;
				$keyword_start_date			=	$keyword->keyword_start_date;
				$keyword_end_date			=	$keyword->keyword_end_date;
				$keyword_smsuid				=	$keyword->keyword_smsuid;
				
				$keyword_setget	=	new DS_Keyword_SetGet();
				
				$keyword_setget->setKeyword_id($keyword_id);
				$keyword_setget->setKeyword_title($keyword_title);
				$keyword_setget->setKeyword_response($keyword_response);
				$keyword_setget->setKeyword_active($keyword_active);
				
				$keyword_setget->setKeyword_admin_only($keyword_admin_only);
				$keyword_setget->setKeyword_auto_replay($keyword_auto_replay);
				$keyword_setget->setKeyword_start_date($keyword_start_date);
				$keyword_setget->setKeyword_end_date($keyword_end_date);
				$keyword_setget->setKeyword_smsuid($keyword_smsuid);
				$keyword_setget->setKeyword_special($keyword->is_special);
				
				
				$keyword_list_arr[]	=	$keyword_setget;
			}
		}
		return $keyword_list_arr;
	}

	public function get_keyword_details_by_id(DS_Keyword_SetGet $keyword_setget){
		global $wpdb;
		$keyword_list_arr	=	array();
		$table	=	$wpdb->prefix.'keyword';
		
		$keyword_id	=	$keyword_setget->getKeyword_id();
		
		$keyword = $wpdb->get_row( 
			"SELECT
			
			keyword_id, keyword_title, keyword_smsuid, keyword_admin_only, keyword_auto_replay, 
			keyword_start_date, keyword_end_date, keyword_response, keyword_active, is_special
			
			FROM $table
			WHERE keyword_id	=	$keyword_id and  keyword_status = 1"	);
		if($keyword){
		
				$keyword_id					=	$keyword->keyword_id;
				$keyword_title				=	$keyword->keyword_title;
				$keyword_response			=	$keyword->keyword_response;
				$keyword_active				=	$keyword->keyword_active;
				$keyword_admin_only			=	$keyword->keyword_admin_only;
				$keyword_auto_replay		=	$keyword->keyword_auto_replay;
				$keyword_start_date			=	$keyword->keyword_start_date;
				$keyword_end_date			=	$keyword->keyword_end_date;
				$keyword_smsuid				=	$keyword->keyword_smsuid;
				
				$keyword_setget	=	new DS_Keyword_SetGet();
				
				$keyword_setget->setKeyword_id($keyword_id);
				$keyword_setget->setKeyword_title($keyword_title);
				$keyword_setget->setKeyword_response($keyword_response);
				$keyword_setget->setKeyword_active($keyword_active);
				$keyword_setget->setKeyword_admin_only($keyword_admin_only);
				$keyword_setget->setKeyword_auto_replay($keyword_auto_replay);
				$keyword_setget->setKeyword_start_date($keyword_start_date);
				$keyword_setget->setKeyword_end_date($keyword_end_date);
				$keyword_setget->setKeyword_smsuid($keyword_smsuid);
				$keyword_setget->setKeyword_special($keyword->is_special);
				
				
				
			
		}else{
			return false;
		}
		return $keyword_setget;
	}
	public function delete(DS_Keyword_SetGet $keyword_obj){
		if($keyword_obj->getKeyword_id()){
			global $wpdb;
			$table	=	$wpdb->prefix.'keyword';
			$keyword_id	=	$keyword_obj->getKeyword_id();
			$data	=	array( 
						'keyword_status' 	=> 0 
					);
			$where		=	array('keyword_id'	=> $keyword_id);
			$keyword_update_return		=	$wpdb->update( $table,  $data , $where);
			return $keyword_update_return;
		}else{
			return false;
		}
	}
}