<?php

add_action( 'init', 'create_role_post_types' );
function create_role_post_types() {
	 $labels = array(
		'name' 				=> _x( 'Role Capabilities', 'taxonomy general name' ),
		'singular_name' 	=> _x( 'Role Capability', 'taxonomy singular name' ),
		'search_items' 		=> __( 'Search Role Capabilities' ),
		'all_items' 		=> __( 'All Role Capabilities' ),
		'role_item' 		=> __( 'Parent Role Capability' ),
		'role_item_colon'	=> __( 'Parent Role Capability:' ),
		'edit_item' 		=> __( 'Edit Role Capability' ), 
		'update_item' 		=> __( 'Update Role Capability' ),
		'add_new_item' 		=> __( 'Add New Role Capability' ),
		'new_item_name' 	=> __( 'New Role Capability Name' ),	
	 
 		'menu_name'		=> 'Role Capabilites',
 		
  ); 	
  
 register_taxonomy('grid_role_capability',array('grid_roles'), array(
		'hierarchical'	=> true,
		'labels'		=> $labels,
		'show_ui'		=> true,
		'query_var'		=> true,
		'rewrite'		=> array( 'slug' => 'role-capability' ),
 		'show_admin_column' => true,
 		'show_in_nav_menus'		=>	true,
  'public'        => true,
  ));
  register_post_type( 'grid_roles',
		array(
			'labels' => array(
				'name' => __( 'Roles' ),
				'singular_name' => __( 'Role' ),
				'add_new' => _x('Add New Role', 'Role'),
    			'add_new_item' => __('Add New Role'),
				'edit_item'	=>	__( 'Edit Role'),
				 'view_item' => __('View Role'),
				'add_new_item'	=>	__( 'Add Role')

			),
			'public' => true,
			'menu_position' => 10,
			'menu_icon' => admin_url('images/generic.png'),
			'show_ui' => true,
			'capability_type' => 'post',
			'rewrite' => array( 'slug' => 'role', 'with_front' => false ),
			'taxonomies' => array( 'Roles'),
			'supports' => array(
			 'title',
	  'editor',
	  'excerpt',
	  'revisions',
	  'thumbnail',
	  'custom-fields',
	  'author',
	  )
		)
	);
  
  
}	




