$(document).ready(function() {
	//$( ".contest-prize-list-ul" ).sortable();
	//$( ".contest-prize-list-ul" ).disableSelection();
	$(document).on('click', '.delete-prize-btn', function(){
		var prize_li	=	$(this).parents('.prize-li');
		prize_li.hide();
		prize_li.find('.contest_prize_status',this).val(0);		
	});
	$('.add-prize-money-btn').click(function(){
		var prize_money_li_clone	=	$('.prize-money-li-clone').clone();
		$('.contest-prize-list-ul').append(prize_money_li_clone.html());
		update_contest_prize_json();
	});
	$('.add-prize-gift-btn').click(function(){
		var prize_gift_li_clone	=	$('.prize-gift-li-clone').clone();
		$('.contest-prize-list-ul').append(prize_gift_li_clone.html());	
		update_contest_prize_json();
	});
	
	update_contest_prize_json();
	$('.contest_start_date').datetimepicker({
    	
    	format: 'DD/MM/YYYY'
    });
    $('.contest_end_date').datetimepicker({
    	format: 'DD/MM/YYYY',
        useCurrent: false //Important! See issue #1075
    });
    $(".contest_start_date").on("dp.change", function (e) {
        $('.contest_end_date').data("DateTimePicker").minDate(e.date);
    });
    $(".contest_end_date").on("dp.change", function (e) {
        $('.contest_start_date').data("DateTimePicker").maxDate(e.date);
    });
    $('#contest_form').submit(function(){
    	update_contest_prize_json();
    });
    $('#contest_form').validate({
        focusInvalid: false,
        ignore: "",
        rules: {
    		contest_title: {
    			minlength	:	2,
    			maxlength	:	100,
                required	:	true
            },
            contest_start_date: {
            
            	required	:	true
               
            },
           
            contest_end_date: {
            	required	:	true
            },
		/*	 contest_keyword: {
              	required	:	true
              }*/
		}
       
    });
    
    view_contest_table	=	$("#view_contest_table").DataTable({
		bSort: false,
	    responsive: true,
	   
	    aLengthMenu: [
	        [10, 25, 50, 100, -1],
	        [10, 25, 50, 100, "All"]
	    ],
		"dom": '<"top"iflp<"clear">>rt<"bottom"iflp<"clear">>',
		bFilter: false,
		"bLengthChange": false,
	});
    $(document).on('click', '.delete_post_row_btn',  function(){
		var current_tr		=	$(this).parents('tr');
		var post_id			=	$('.row_id',current_tr).val();
		var row_title_td	=	$('.row_title_td',current_tr).text();
		
		var confirm_flag = confirm("Are you sure, Do you want to delete "+row_title_td+"?");
		if (confirm_flag == true) {
			var delete_ajax_url	=	get_template_directory_uri()+'/ajax-delete.php';
			$.ajax({
				  method: "POST",
				  url: delete_ajax_url,
				  data: {controller: 'contest', action: 'delete', id : post_id }
			})
			  .done(function( data ) {
				if(data){
			    	view_contest_table.row(current_tr).remove().draw( false );
					showSuccess("Deleted Successfully!");
			    }else{
			    	showSuccess('Please try again!');
			    }
			});
		} else {
		   
		}
		return false;
	});
	
	if($('.contest_keyword_hidden').size()){
		$('.contest_keyword option[value="'+$('.contest_keyword_hidden').val()+'"]').attr('selected','selected');
	}
	
});
function update_contest_prize_json(){
	var contest_prize_list_ul	=	$('.contest-prize-list-ul');
	if($('.prize-li',contest_prize_list_ul).size()){
		var contest_prize_arr	=	[];
		$('.prize-li',contest_prize_list_ul).each(function(){
			this_li	= $(this);
			var contest_prize	=	{};
			if(this_li.hasClass('prize-money-li')){
				contest_prize.contest_prize_type		=	'money';				 
			}else if(this_li.hasClass('prize-gift-li')){
				contest_prize.contest_prize_type		=	'gift';
			}
			contest_prize.contest_prize_id			=	$('.contest_prize_id'		,this_li).val();
			contest_prize.contest_prize_title		=	$('.contest_prize_title'	,this_li).val();
			contest_prize.contest_prize_amount		=	$('.contest_prize_amount'	,this_li).val();
			contest_prize.contest_prize_status		=	$('.contest_prize_status'	,this_li).val();
			
			contest_prize_arr.push(contest_prize);
		});
		contest_prize_json	=	JSON.stringify(contest_prize_arr);
		
		$('#contest_prize_hidden_json').val(contest_prize_json);
		
	}
}
