$(document).ready(function() {
	var obj;
	if($('#program_rjs_prev').size() && $('#program_rjs_prev').val() != ''){
		var program_rjs_prev	=	jQuery.parseJSON($('#program_rjs_prev').val());
		
		if(program_rjs_prev){
			$.each( program_rjs_prev, function( key, value ) {
					
				  $('#program_rjs option[value="'+value+'"]').attr('selected','selected');
			});
		}
	}
	if($('#program_days_prev').size() && $('#program_days_prev').val() != ''){
		var program_days_prev	=	jQuery.parseJSON($('#program_days_prev').val());
		if(program_days_prev){
			$.each( program_days_prev, function( key, value ) {
				 $("#program_day_"+value).attr('checked','checked');
			});
		}
	}
    $('#add_program_form').validate({
            focusInvalid: false,
            ignore: "",
            rules: {
        		program_title: {
        			minlength	:	2,
        			maxlength	:	100,
                    required	:	true
                },
                program_genre: {
                	minlength	:	2,
        			maxlength	:	100,
                    required	:	true
                },
                program_time_span: {
                	minlength	:	1,
        			maxlength	:	3,
        			digits		:	true,
                    required	:	true
                },
                program_start_time: {
                	minlength:	2,
        			maxlength:	100,
                    required: true
                },
                program_end_time: {
                	minlength:	2,
        			maxlength:	100,
                    required: true
                },
                /*program_start_date: {
                	minlength:	2,
        			maxlength:	100,
                    required: true
                },
                program_end_date: {
                	minlength:	2,
        			maxlength:	100,
                    required: true
                },*/
                program_days: {
                	required: true
                },
                'program_rjs[]': {
                	minlength:	1,
        			maxlength:	100,
                    required: true
                }
                
                
                
               

            },
            messages: {
				user_email: {					
					remote: jQuery.validator.format("This email is already in registered!")
				}
			}
        });
    
     
    $('.program_start_date').datetimepicker({
    	
    	format: 'DD/MM/YYYY'
    });
    $('.program_end_date').datetimepicker({
    	format: 'DD/MM/YYYY',
        useCurrent: false //Important! See issue #1075
    });
    $(".program_start_date").on("dp.change", function (e) {
        $('.program_end_date').data("DateTimePicker").minDate(e.date);
    });
    $(".program_end_date").on("dp.change", function (e) {
        $('.program_start_date').data("DateTimePicker").maxDate(e.date);
    });
    
    $('.program_start_time').datetimepicker({
    	format: 'hh:mm A'
    });
    $('.program_end_time').datetimepicker({
    	format: 'hh:mm A'
    });
  

    
    
    $("#program_rjs").select2({
        placeholder: 'Select RJ\'s',
        allowClear: true
    }).on('select2-open', function() {
        // Adding Custom Scrollbar
        $(this).data('select2').results.addClass('overflow-hidden').perfectScrollbar();
    });
    
    view_programs_table	=	$("#view_programs_table").DataTable({
		bSort: false,
	    responsive: true,
	   
	    aLengthMenu: [
	        [10, 25, 50, 100, -1],
	        [10, 25, 50, 100, "All"]
	    ],
		"dom": '<"top"iflp<"clear">>rt<"bottom"iflp<"clear">>',
		bFilter: false,
		"bLengthChange": false
	});
    
    $(document).on('click', '.delete_post_row_btn',  function(){

		
		var current_tr		=	$(this).parents('tr');
		var post_id			=	$('.row_id',current_tr).val();
		var row_title_td	=	$('.row_title_td',current_tr).text();
		var confirm_flag = confirm("Are you sure, Do you want to delete "+row_title_td+"?");
		if (confirm_flag == true) {
			var delete_ajax_url	=	get_template_directory_uri()+'/ajax-delete.php';
			$.ajax({
				  method: "POST",
				  url: delete_ajax_url,
				  data: {controller: 'program', action: 'delete', id : post_id }
			})
			  .done(function( data ) {
				 if(data){
			    	view_programs_table.row(current_tr).remove().draw( false );
					showSuccess("Deleted Successfully!");
			    }else{
			    	showSuccess('Please try again!');
			    }
			});
		} else {
		   
		}
		return false;
	});
	
});
