$(document).ready(function(){
	$('#add_quiz_form').validate({
        focusInvalid: false,
        ignore: "",
        rules: {
			quiz_title: {
    			minlength	:	2,
    			maxlength	:	200,
                required	:	true
            },
            quiz_start_date: {
            	required	:	true
            },
            quiz_end_date: {
            	required	:	true
            },
            quiz_keyword: {
             	required	:	true
             },
             quiz_response: {
            	maxlength	:	160
            },
            quiz_description: {
            	maxlength	:	500
            }
             
            
			}
       
    });
	$('.quiz_start_date').datetimepicker({
    	format: 'DD/MM/YYYY'
    });
    
	$('.quiz_end_date').datetimepicker({
    	format: 'DD/MM/YYYY',
        useCurrent: false 
    });
    
	$(".quiz_start_date").on("dp.change", function (e) {
        $('.quiz_end_date').data("DateTimePicker").minDate(e.date);
    });
    
	$(".quiz_end_date").on("dp.change", function (e) {
        $('.quiz_start_date').data("DateTimePicker").maxDate(e.date);
    });
	view_programs_table	=	$("#view_quiz_table").DataTable({
		bSort: false,
	    responsive: true,
	   
	    aLengthMenu: [
	        [10, 25, 50, 100, -1],
	        [10, 25, 50, 100, "All"]
	    ],
		"dom": '<"top"iflp<"clear">>rt<"bottom"iflp<"clear">>',
		bFilter: false,
		"bLengthChange": false
	});
	if($('.quiz_keyword_hidden').size()){
		$('.quiz_keyword option[value="'+$('.quiz_keyword_hidden').val()+'"]').attr('selected','selected');
	}
	if($('.quiz_alternate_keyword_hidden').size()){
		$('.quiz_alternate_keyword option[value="'+$('.quiz_alternate_keyword_hidden').val()+'"]').attr('selected','selected');
	}
	
	$(document.body).on('blur', '.quiz_question_title', function() {
    	update_quiz_question_answer_json();
    });
    $('#add_quiz_form').submit(function(){
    	update_quiz_question_answer_json();
    });
	$('.add-question-btn').click(function(){
		var total_question = $('#total_question').val();
		var question_row_clone_1	=	$('.question-row-clone');
		total_question = parseInt(total_question) + 1;
		//console.log(total_question);
		$('.question_number',question_row_clone_1).html('Q '+total_question);
		question_row_clone	=	$('.question-row-clone').clone();
	//	console.log(question_row_clone);
		$('.question-rows-list').append(question_row_clone.html());
		$('#total_question').val(total_question);
		update_correct_answer_radio_btn();
	});
	
    if(!$('.question-rows-list .question-row').size()){
		$('.add-question-btn').trigger('click');
	}
	if($('#quiz_active_hidden').size() && $('#quiz_active_hidden').val() != ''){
		$('[name="quiz_active"][value="'+$('#quiz_active_hidden').val()+'"]').attr('checked','checked');
	}
	$(document).on('click','.delete-question-btn', function(){
		$(this).parents('.question-row').find('.quiz_question_status').val(0);
		$(this).parents('.question-row').hide();
		var total_question = $('#total_question').val();
		total_question = parseInt(total_question) - 1;
		$('#total_question').val(total_question);
		
	});
	$(document).on('click','.add-answer-btn', function(){	
		answer_row_clone	=	$('.answer-row-clone').clone();
		$(this).parents('.question-row').find('.answer-rows-list').append(answer_row_clone.html());
		update_correct_answer_radio_btn();
	});
	$(document).on('click','.delete-answer-btn', function(){	
		$(this).parents('.answer-row').find('.quiz_answer_status').val(0);
		$(this).parents('.answer-row').hide();
	});
	update_correct_answer_radio_btn();
	
	$(document).on('click', '.delete_post_row_btn',  function(){

		
		var current_tr		=	$(this).parents('tr');
		var post_id			=	$('.row_id',current_tr).val();
		var row_title_td	=	$('.row_title_td',current_tr).text();
		var confirm_flag = confirm("Are you sure, Do you want to delete "+row_title_td+"?");
		if (confirm_flag == true) {
			var delete_ajax_url	=	get_template_directory_uri()+'/ajax-delete.php';
			$.ajax({
				  method: "POST",
				  url: delete_ajax_url,
				  data: {controller: 'quiz', action: 'delete', id : post_id}
			})
			  .done(function( data ) {
				if(data){
			    	view_programs_table.row(current_tr).remove().draw( false );
					showSuccess("Deleted Successfully!");
			    }else{
			    	showSuccess('Please try again!');
			    }
			});
		} else {
		   
		}
		return false;
	});	
});



function update_correct_answer_radio_btn(){
	var i = 1;
	$('.question-row').each(function(){
		name_var	=	'quiz_answer_correct_answer_group_'+i;
		$(' .answer-row .quiz_answer_correct_answer',this).attr({'name':name_var});
		i++;
	});
}

function update_quiz_question_answer_json(){
	
	var quiz_question_list_ul	=	$('.question-rows-list');
	if($('.question-row',quiz_question_list_ul).size()){
		var quiz_question_arr	=	[];
		$('.question-row',quiz_question_list_ul).each(function(){
			question_row	= $(this);
			var quiz_question	=	{};
			if($('.quiz_question_title',question_row).val()	!= ''){
				quiz_question.quiz_question_id		=	$('.quiz_question_id',question_row).val();
				quiz_question.quiz_question_title	=	$('.quiz_question_title',question_row).val();
				quiz_question.quiz_question_keyword	=	$('.quiz_question_keyword',question_row).val();
				quiz_question.quiz_question_status	=	$('.quiz_question_status',question_row).val();
				console.log(quiz_question);
				var quiz_answer_arr	=	[];
				if($('.answer-row',question_row).size()){
					$('.answer-row',question_row).each(function(){
						var answer_row	= $(this);
						var quiz_answer	=	{};
						if($('.quiz_answer_title',answer_row).val()	!= ''){
							answer_row.quiz_answer_id				=	$('.quiz_answer_id',answer_row).val();
							answer_row.quiz_answer_title			=	$('.quiz_answer_title',answer_row).val();
							answer_row.quiz_suggested_answers			=	$('.quiz_suggested_answers',answer_row).val();
							answer_row.quiz_answer_correct_answer	=	$('.quiz_answer_correct_answer',answer_row).is(':checked') ? 1:0;
							answer_row.quiz_answer_status			=	$('.quiz_answer_status',answer_row).val();
						}
						quiz_answer_arr.push(answer_row);
						quiz_question.quiz_answer_json	=	quiz_answer_arr;
					});	
					
				}
				quiz_question_arr.push(quiz_question);
			}
		});
		quiz_question_json	=	JSON.stringify(quiz_question_arr);
		$('#quiz_question_answer_json').val(quiz_question_json);
	}
	
}