<?php
class DS_Contest_Controller{
	
	function __construct( ){
		
	}
	
	public function save_contest(){
		
		if(isset($_REQUEST['contest_id'])){
			$contest_id	=	$_REQUEST['contest_id'];
		}else{
			$contest_id	=	false;
		}
		$contest_title					=	$_REQUEST['contest_title'];
		$contest_keyword					=	$_REQUEST['contest_keyword'];
		$contest_end_date				=	$_REQUEST['contest_end_date'];
		$contest_start_date				=	$_REQUEST['contest_start_date'];
		$contest_prize_hidden_json		=	$_REQUEST['contest_prize_hidden_json'];
		
		if($contest_start_date){
			$contest_start_date	=	ds_format_date($contest_start_date);
		}
		
		if($contest_end_date){
			$contest_end_date	=	ds_format_date($contest_end_date);
			$contest_end_date	=	ds_end_date_time_setup($contest_end_date);
		}
		
		$contest_obj	=	new DS_Contest_SetGet();
		
		$contest_obj->setContest_title				($contest_title);
		$contest_obj->setContest_start_date			($contest_start_date);
		$contest_obj->setContest_end_date			($contest_end_date);
		$contest_obj->setContest_author_id			(get_current_user_id());
		$contest_obj->setContest_prize_hidden_json	($contest_prize_hidden_json);
		$contest_obj->setContest_keyword	($contest_keyword);
		if($contest_id){
			$contest_obj->setContest_id($contest_id);
		}
		
		$contest_id	=	$this->update_contest( $contest_obj );
		
		return $contest_id;
	}
	public function get_contests(){
		global $wpdb;
		$contest_list_arr	=	array();
		$table	=	$wpdb->prefix.'contest';
		
		$contest_list = $wpdb->get_results( 
			"SELECT contest_id, contest_title, contest_start_date, contest_end_date, contest_author_id,contest_keyword
			FROM $table
			WHERE contest_status = 1"	);
		if($contest_list){
			foreach ($contest_list as $contest){
				$contest_id						=	$contest->contest_id;
				$contest_title					=	$contest->contest_title;
				$contest_end_date				=	$contest->contest_end_date;
				$contest_start_date				=	$contest->contest_start_date;
				$contest_status					=	$contest->contest_status;
				
				$contest_obj	=	new DS_Contest_SetGet();
				$contest_obj->setContest_id			($contest_id);
				$contest_obj->setContest_title		($contest_title);
				$contest_obj->setContest_start_date	($contest_start_date);
				$contest_obj->setContest_end_date	($contest_end_date);
				$contest_obj->setContest_author_id	(get_current_user_id());
				$contest_obj->setContest_status		($contest_status);
				$contest_obj->setContest_keyword		($contest_keyword);
				$contest_list_arr[]	=	$contest_obj;
			}
		}
		return $contest_list_arr;
	}
	public function get_contests_by_date(){
		global $wpdb;
		$contest_list_arr	=	array();
		$table	=	$wpdb->prefix.'contest';
		$currentDateStart = date('Y-m-d 00:00:00');
		$currentDateEnd = date('Y-m-d 23:59:59');
		
		$contest_list = $wpdb->get_results( 
			"SELECT contest_id, contest_title, contest_start_date, contest_end_date, contest_author_id,contest_keyword
			FROM $table
			WHERE contest_status = 1 AND contest_start_date <= '$currentDateStart' AND contest_end_date >= '$currentDateEnd'"  );
		if($contest_list){
			foreach ($contest_list as $contest){
				$contest_id						=	$contest->contest_id;
				$contest_title					=	$contest->contest_title;
				$contest_end_date				=	$contest->contest_end_date;
				$contest_start_date				=	$contest->contest_start_date;
				$contest_status					=	$contest->contest_status;
				
				$contest_obj	=	new DS_Contest_SetGet();
				$contest_obj->setContest_id			($contest_id);
				$contest_obj->setContest_title		($contest_title);
				$contest_obj->setContest_start_date	($contest_start_date);
				$contest_obj->setContest_end_date	($contest_end_date);
				$contest_obj->setContest_author_id	(get_current_user_id());
				$contest_obj->setContest_status		($contest_status);
				$contest_list_arr[]	=	$contest_obj;
			}
		}
		return $contest_list_arr;
	}
	public function get_contest_details_by_id(DS_Contest_SetGet $contest){
		if($contest->getContest_id()){
			$contest_id	=	$contest->getContest_id();
			$contest_obj	= false;
			global $wpdb;
			$table	=	$wpdb->prefix.'contest';
			$contest_list_arr	=	array();
			$contest = $wpdb->get_row( 
				"SELECT contest_id, contest_title, contest_start_date, contest_end_date, contest_author_id,contest_keyword
				FROM $table
				WHERE contest_id = $contest_id and contest_status = 1 "	);
			
			if($contest){
				
					$contest_id						=	$contest->contest_id;
					$contest_title					=	$contest->contest_title;
					$contest_end_date				=	$contest->contest_end_date;
					$contest_start_date				=	$contest->contest_start_date;
					$contest_status					=	$contest->contest_status;
					$contest_keyword					=	$contest->contest_keyword;
					
					$contest_prize_obj	=	new DS_Contest_Prizes_SetGet();
					$contest_prize_obj->setContest_prize_contest_id($contest_id);
					$contest_prize_list	=	$this->get_contest_prize_list_by_contest_id($contest_prize_obj);
					
					$contest_obj	=	new DS_Contest_SetGet();
					$contest_obj->setContest_id			($contest_id);
					$contest_obj->setContest_title		($contest_title);
					$contest_obj->setContest_start_date	($contest_start_date);
					$contest_obj->setContest_end_date	($contest_end_date);
					$contest_obj->setContest_author_id	(get_current_user_id());
					$contest_obj->setContest_status		($contest_status);
					$contest_obj->setContest_keyword		($contest_keyword);
					$contest_obj->setContest_prize_list($contest_prize_list);
				
			}
			return $contest_obj;
			
		}else{
			return false;
		}
	}
	public function update_contest(DS_Contest_SetGet $contest_obj){
		global $wpdb;
		$table	=	$wpdb->prefix.'contest';
		$db_transaction_flag	=	true;
		$data	=	array( 
						'contest_title' 		=> $contest_obj->getContest_title(), 
						'contest_start_date' 	=> $contest_obj->getContest_start_date(), 
						'contest_end_date' 		=> $contest_obj->getContest_end_date(), 
						'contest_author_id' 	=> $contest_obj->getContest_author_id(),
						'contest_keyword' 	=> $contest_obj->getContest_keyword(),
					);
					
		$wpdb->query('START TRANSACTION');
		 			
		if($contest_obj->getContest_id()){
			$contest_id	=	$contest_obj->getContest_id();
			$where	=	array('contest_id'	=> $contest_id);
			$update_flag	=	$wpdb->update( $table,  $data , $where);
			if($update_flag	=== false){
				$db_transaction_flag	=	$contest_id	=	false;			
			}
		}else{
			$insert_flag	=	$wpdb->insert( $table,  $data);
			if($insert_flag){
				$contest_id	=	$wpdb->insert_id;	
			}else{
				$db_transaction_flag	=	false;
			}
			
		}
		if($contest_id && $db_transaction_flag){
			$prize_json	=	$contest_obj->getContest_prize_hidden_json();
			if($prize_json){
				$prize	= json_decode (stripslashes($prize_json));
				foreach($prize as $prize){
					$prize_obj = new DS_Contest_Prizes_SetGet();
					
					$contest_prize_id			=	$prize->contest_prize_id;
					$contest_prize_contest_id	=	$contest_id;
					$contest_prize_type			=	$prize->contest_prize_type;
					$contest_prize_title		=	$prize->contest_prize_title;
					$contest_prize_amount		=	$prize->contest_prize_amount;
					$contest_prize_status		=	$prize->contest_prize_status;
					
					if($contest_prize_id){
						$prize_obj->setContest_prize_id	($contest_prize_id);	
					}
					if($contest_prize_status != ''){
						$prize_obj->setContest_prize_status($contest_prize_status);
					}
					$prize_obj->setContest_prize_contest_id($contest_prize_contest_id); 
					$prize_obj->setContest_prize_type		($contest_prize_type); 
					$prize_obj->setContest_prize_title		($contest_prize_title); 
					$prize_obj->setContest_prize_amount	($contest_prize_amount);
					$prize_id	=	$this->update_contest_prize($prize_obj);
					if($prize_id === false){
						$db_transaction_flag	=	false;
						break;
					}
				}
				//wp_update_contest_prize($prize);
			}
		}else{
			$db_transaction_flag	=	false;
		}
		if($db_transaction_flag){
			$wpdb->query('COMMIT');		
		}else{
			$wpdb->query('ROLLBACK');
			$contest_id	=	false;
		}
		return $contest_id;
	}
	public function update_contest_prize(DS_Contest_Prizes_SetGet $prize_obj){
		global $wpdb;
		$table	=	$wpdb->prefix.'contest_prize';
		
		
		$data	=	array( 
						'contest_prize_contest_id' 	=> $prize_obj->getContest_prize_contest_id(), 
						'contest_prize_type' 		=> $prize_obj->getContest_prize_type(), 
						'contest_prize_title' 		=> $prize_obj->getContest_prize_title(), 
						'contest_prize_amount' 		=> $prize_obj->getContest_prize_amount(),
					);
		if($prize_obj->getContest_prize_status() == 0 && $prize_obj->getContest_prize_id()){
			$prize_id	=	$prize_obj->getContest_prize_id();
			$where		=	array('contest_prize_id'	=> $prize_id);
			$prize_id	=	$wpdb->delete( $table,  $where);
		}else if($prize_obj->getContest_prize_id()){
			$prize_id	=	$prize_obj->getContest_prize_id();
			$where		=	array('contest_prize_id'	=> $prize_id);
			$prize_id	=	$wpdb->update( $table,  $data , $where);
		}else{
			$prize_id	=	$wpdb->insert( $table,  $data);
		}
		
		return $prize_id;
		
	}
	public function get_contest_prize_list_by_contest_id(DS_Contest_Prizes_SetGet $contest_prize){
		if($contest_prize->getContest_prize_contest_id()){
			
			global $wpdb;
			$table	=	$wpdb->prefix.'contest_prize';
			
			$contest_prize_contest_id	=	$contest_prize->getContest_prize_contest_id();
			$contest_prize_obj	= false;
			
			$contest_prize_arr = $wpdb->get_results( 
				"SELECT 
					contest_prize_id,
					contest_prize_type, 
					contest_prize_title, 
					contest_prize_amount 			
				FROM $table
				WHERE 
					contest_prize_contest_id = $contest_prize_contest_id and 
					contest_prize_status = 1 "	
			);
			
			if($contest_prize_arr){
				
				$contest_prize_list_arr	=	array();
				foreach ($contest_prize_arr as $contest_prize){
				
					$contest_prize_id				=	$contest_prize->contest_prize_id;
					$contest_prize_type			=	$contest_prize->contest_prize_type;
					$contest_prize_title			=	$contest_prize->contest_prize_title;
					$contest_prize_amount			=	$contest_prize->contest_prize_amount;
					
					$contest_prize_obj		=	new DS_Contest_Prizes_SetGet();
					$contest_prize_obj->setContest_prize_id($contest_prize_id);
					$contest_prize_obj->setContest_prize_contest_id($contest_prize_contest_id);
					$contest_prize_obj->setContest_prize_title($contest_prize_title);
					$contest_prize_obj->setContest_prize_type($contest_prize_type);
					$contest_prize_obj->setContest_prize_amount($contest_prize_amount);
					$contest_prize_list_arr[]	=	$contest_prize_obj;
				
				}
				
			}else{
				
				$contest_prize_list_arr	=	false;
				
			}
			
			return $contest_prize_list_arr;
			
		}else{
			
			return false;
			
		}
		
	}
	public function delete_contest($contest_id){
		if($contest_id){
			global $wpdb;
			$table	=	$wpdb->prefix.'contest';
			$data	=	array( 
							'contest_status' 		=> 0
						);
			$where	=	array('contest_id'	=> $contest_id);
			$contest_id	=	$wpdb->update( $table,  $data , $where);
			
			return $contest_id;
		}else{
			return false;
		}
	}
	public function delete($contest_id){
		global $wpdb;
		$contest_model	=	new DS_Contest_Model();
		$contest_obj	=	new DS_Contest_SetGet();
		$contest_obj->setContest_id($contest_id);
		$updateQuiz = $wpdb->query("UPDATE wp_keyword SET connected_type = '', connected_id = 0 WHERE connected_id = ".$contest_id);
		$contest_details	=	$contest_model->delete($contest_obj);
		
		
		return $contest_details;
	
	}
}