<?php
Class DS_Poll_Model{
	public function update_poll(DS_Poll_SetGet $poll_obj){
		global $wpdb;
		$table	=	$wpdb->prefix.'poll';
		$db_transaction_flag	=	true;
		$data	=	array( 
						'poll_title'		=>	$poll_obj->getPoll_title(),
						'poll_start_date'	=>	$poll_obj->getPoll_start_date(),
						'poll_end_date'		=>	$poll_obj->getPoll_end_date(),
						'poll_keyword'		=>	$poll_obj->getPoll_keyword(),
						'poll_response'		=>	$poll_obj->getPoll_response(),
						'poll_active'		=>	$poll_obj->getPoll_active(), 
					);
					
					
		//$wpdb->query('START TRANSACTION');
		 			
		if($poll_obj->getPoll_id()){
			$poll_id	=	$poll_obj->getPoll_id();
			$where	=	array('poll_id'	=> $poll_id);
			$update_flag	=	$wpdb->update( $table,  $data , $where);
			if($update_flag	=== false){
				$db_transaction_flag	=	$poll_id	=	false;			
			}
		}else{
			$insert_flag	=	$wpdb->insert(	$table,	$data	);
			if($insert_flag){
				$poll_id	=	$wpdb->insert_id;	
			}else{
				$db_transaction_flag	=	false;
			}
			
		}
		if($poll_id && $db_transaction_flag){
			$choice_json	=	$poll_obj->getPoll_choice_json();
			if($choice_json){
				$choice_list	= json_decode (stripslashes($choice_json));
				foreach($choice_list as $choice_answer){
					$choice_obj = new DS_Poll_Choice_SetGet();
					
					
					$poll_choice_poll_id		=	$poll_id;
					$poll_choice_id				=	$choice_answer->poll_choice_id;
					$poll_choice_title			=	$choice_answer->poll_choice_title;
					$poll_choice_vote_count		=	$choice_answer->poll_choice_vote_count;
					$poll_choice_status			=	$choice_answer->poll_choice_status;
					
					
					$choice_obj->setPoll_choice_poll_id($poll_choice_poll_id); 
					$choice_obj->setPoll_choice_title($poll_choice_title);
					$choice_obj->setPoll_choice_vote_count($poll_choice_vote_count);
					
					if($poll_choice_id){
						$choice_obj->setPoll_choice_id($poll_choice_id);	
					}
					if($poll_choice_status != ''){
						$choice_obj->setPoll_choice_status($poll_choice_status);
					}
				
					$choice_id	=	$this->update_poll_choice($choice_obj);
				
				}
				//wp_update_poll_prize($prize);
			}
		}else{
			$db_transaction_flag	=	false;
		}
		if($db_transaction_flag){
			//$wpdb->query('COMMIT');		
		}else{
			//$wpdb->query('ROLLBACK');
			$poll_id	=	false;
		}
		return $poll_id;
	}
	public function update_poll_choice(DS_Poll_Choice_SetGet $choice_obj){
		global $wpdb;
		$table	=	$wpdb->prefix.'poll_choice';
		
		
		$data	=	array( 
						'poll_choice_poll_id' 		=> $choice_obj->getPoll_choice_poll_id(), 
						'poll_choice_title' 		=> $choice_obj->getPoll_choice_title(),
						'poll_choice_vote_count' 	=> $choice_obj->getPoll_choice_vote_count(),
					);
		if($choice_obj->getPoll_choice_status() == 0 && $choice_obj->getPoll_choice_id()){
			$choice_id	=	$choice_obj->getPoll_choice_id();
			$where		=	array('poll_choice_id'	=> $choice_id);
			$choice_delete_return	=	$wpdb->delete( $table,  $where);
			if($choice_delete_return === false){
				$choice_id	=	false;
			}
		}else if($choice_obj->getPoll_choice_id()){
			$choice_id	=	$choice_obj->getPoll_choice_id();
			$where		=	array('poll_choice_id'	=> $choice_id);
			
			$choice_update_return	=	$wpdb->update( $table,  $data , $where);
			if($choice_update_return === false){
				$choice_id	=	false;
			}
		}else{
			$choice_id	=	$wpdb->insert( $table,  $data);
			if($choice_id) $choice_id	=	$wpdb->insert_id;
		}
		
		return $choice_id;
		
	}
	public function get_polls(){
		global $wpdb;
		$poll_list_arr	=	array();
		$table	=	$wpdb->prefix.'poll';
		
		$poll_list = $wpdb->get_results( 
			"SELECT 
			
			poll_id, 
			poll_title, 
			poll_start_date, 
			poll_end_date, 
			poll_keyword, 
			poll_response, 
			poll_created_date, 
			poll_updated_date, 
			poll_active
			
			FROM $table
			WHERE poll_status = 1 ORDER BY poll_id desc"	);
		if($poll_list){
			foreach ($poll_list as $poll){
				
				$poll_id			=	$poll->poll_id; 
				$poll_title 		=	$poll->poll_title; 
				$poll_start_date 	=	$poll->poll_start_date; 
				$poll_end_date 		=	$poll->poll_end_date; 
				$poll_keyword 		=	$poll->poll_keyword; 
				$poll_response 		=	$poll->poll_response; 
				$poll_created_date 	=	$poll->poll_created_date; 
				$poll_updated_date 	=	$poll->poll_updated_date; 
				$poll_active 		=	$poll->poll_active;
								
				$poll_obj	=	new DS_Poll_SetGet();
				
				$poll_obj->setPoll_id				($poll_id); 
				$poll_obj->setPoll_title 			($poll_title); 
				$poll_obj->setPoll_start_date 		($poll_start_date); 
				$poll_obj->setPoll_end_date 		($poll_end_date); 
				$poll_obj->setPoll_keyword 			($poll_keyword); 
				$poll_obj->setPoll_response 		($poll_response); 
				$poll_obj->setPoll_created_date 	($poll_created_date); 
				$poll_obj->setPoll_updated_date 	($poll_updated_date); 
				$poll_obj->setPoll_active 			($poll_active);
				
				$poll_list_arr[]	=	$poll_obj;
				
			}
		}
		return $poll_list_arr;
	}
	public function get_poll_details_by_id(DS_Poll_SetGet $poll){
		if($poll->getPoll_id()){
			$poll_id	=	$poll->getPoll_id();
			$poll_obj	= false;
			global $wpdb;
			$table	=	$wpdb->prefix.'poll';
			$poll_list_arr	=	array();
			$poll = $wpdb->get_row( 
				"SELECT 
				
				poll_id, 
				poll_title, 
				poll_start_date, 
				poll_end_date, 
				poll_keyword, 
				poll_response, 
				poll_created_date, 
				poll_updated_date, 
				poll_active
				
				FROM $table
				WHERE poll_id = $poll_id and poll_status = 1 "	);
			
			if($poll){
				
					$poll_id			=	$poll->poll_id; 
					$poll_title 		=	$poll->poll_title; 
					$poll_start_date 	=	$poll->poll_start_date; 
					$poll_end_date 		=	$poll->poll_end_date; 
					$poll_keyword 		=	$poll->poll_keyword; 
					$poll_response 		=	$poll->poll_response; 
					$poll_created_date 	=	$poll->poll_created_date; 
					$poll_updated_date 	=	$poll->poll_updated_date; 
					$poll_active 		=	$poll->poll_active;
					
					$poll_obj	=	new DS_Poll_SetGet();
					
					$poll_obj->setPoll_id				($poll_id); 
					$poll_obj->setPoll_title 			($poll_title); 
					$poll_obj->setPoll_start_date 		($poll_start_date); 
					$poll_obj->setPoll_end_date 		($poll_end_date); 
					$poll_obj->setPoll_keyword 			($poll_keyword); 
					$poll_obj->setPoll_response 		($poll_response); 
					$poll_obj->setPoll_created_date 	($poll_created_date); 
					$poll_obj->setPoll_updated_date 	($poll_updated_date); 
					$poll_obj->setPoll_active 			($poll_active);
						
					$poll_choice_obj	=	new DS_Poll_Choice_SetGet();
					$poll_choice_obj->setPoll_choice_poll_id($poll_id);
					$poll_choice_obj	=	$this->get_poll_choice_by_poll_id($poll_choice_obj);
					if($poll_choice_obj){
						$poll_obj->setPoll_choice_obj($poll_choice_obj);
					}
					
				
			}
			return $poll_obj;
			
		}else{
			return false;
		}
	}
	public function get_poll_choice_by_poll_id(DS_Poll_Choice_SetGet $choice_obj){
		if($choice_obj->getPoll_choice_poll_id()){
			$poll_id	=	$choice_obj->getPoll_choice_poll_id();
			$choice_arr	= false;
			global $wpdb;
			$table	=	$wpdb->prefix.'poll_choice';
			$choice_list_arr	=	array();
			$choice_rquery = $wpdb->get_results( 
				"SELECT 
				
				poll_choice_id, 
				poll_choice_title,				
				poll_choice_vote_count
				
				FROM $table
				WHERE poll_choice_poll_id = $poll_id and poll_choice_status = 1 "	);
			if($choice_rquery){
				$choice_arr	=	array();
				foreach($choice_rquery as $choice_row){
					$poll_choice_id			=	$choice_row->poll_choice_id;
					$poll_choice_title		=	$choice_row->poll_choice_title;
					$poll_choice_vote_count	=	$choice_row->poll_choice_vote_count;
					
					$choice_obj	= new DS_Poll_Choice_SetGet();
					$choice_obj->setPoll_choice_id($poll_choice_id);
					$choice_obj->setPoll_choice_title($poll_choice_title);
					$choice_obj->setPoll_choice_vote_count($poll_choice_vote_count);
					
					
					$choice_arr[]	=	$choice_obj;
				}
				return $choice_arr;
			}
		}else{
			return false;
		}
	}
	public function delete(DS_Poll_SetGet $poll_obj){
		if($poll_obj->getPoll_id()){
			global $wpdb;
			$table	=	$wpdb->prefix.'poll';
			$poll_id	=	$poll_obj->getPoll_id();
			$data	=	array( 
						'poll_status' 	=> 0 
					);
			$where		=	array('poll_id'	=> $poll_id);
			$poll_update_return		=	$wpdb->update( $table,  $data , $where);
			return $poll_update_return;
		}else{
			return false;
		}
	}
	
	public function poll_vote($userId,$poll_id,$poll_choice_id){
		
			global $wpdb;
			$table	=	$wpdb->prefix.'poll_votes';
		
		
		$data	=	array( 
						'poll_id' 		=> $poll_id, 
						'poll_choice_id' 		=> $poll_choice_id,
						'user_id' 	=> $userId,
						'ip_address' 	=> $_SERVER['REMOTE_ADDR'],
						'created' 	=> time(),	
					);
					$this->update_poll_vote_count($poll_choice_id,'add');
			$poll_update_return		=	$wpdb->insert( $table,  $data);
			return $poll_update_return;
		
	}
	
	public function poll_vote_cancel($userId,$poll_id,$poll_choice_id){
		
			global $wpdb;
			$this->update_poll_vote_count($poll_choice_id,'remove');
			$wpdb->query( "DELETE FROM wp_poll_votes WHERE user_id=$userId AND poll_id = $poll_id");
			return 1;
		
	}
	public function update_poll_vote_count($poll_choice_id,$action='add'){
		global $wpdb;
		$poll_choice = $wpdb->get_row( "SELECT * FROM wp_poll_choice WHERE poll_choice_id = $poll_choice_id"	);
		$totalChoiceVote = $poll_choice->poll_choice_vote_count;
		if($action == 'add'){
			$totalChoiceVote = $totalChoiceVote + 1;
		}else{
			$totalChoiceVote = $totalChoiceVote - 1;
		}
		$wpdb->query("UPDATE wp_poll_choice SET poll_choice_vote_count = $totalChoiceVote WHERE poll_choice_id = $poll_choice_id");
	}
}
?>