<?php

add_action( 'init', 'create_program_post_types' );
function create_program_post_types() {
	 $labels = array(
		'name' => _x( 'Program Categories', 'taxonomy general name' ),
		'singular_name' => _x( 'Program Category', 'taxonomy singular name' ),
		'search_items' =>  __( 'Search Program Categories' ),
		'all_items' => __( 'All Program Categories' ),
		'parent_item' => __( 'Parent Program Category' ),
		'parent_item_colon' => __( 'Parent Program Category:' ),
		'edit_item' => __( 'Edit Program Category' ), 
		'update_item' => __( 'Update Program Category' ),
		'add_new_item' => __( 'Add New Program Category' ),
		'new_item_name' => __( 'New Program Category Name' ),
 		
  ); 	
  
 register_taxonomy('program_category',array('program_post'), array(
		'hierarchical' => true,
		'labels' => $labels,
		'show_ui' => true,
		'query_var' => true,
		'rewrite' => array( 'slug' => 'program-category' ),
  ));
	register_post_type( 'program_post',
		array(
				'labels' 		=> array(
				'name' 			=> __( 'Programs' ),
				'singular_name' => __( 'Program' ),
				'add_new' 		=> _x('Add New Program', 'Program'),
    			'add_new_item' 	=> __('Add New Program'),
				'edit_item'		=>	__( 'Edit Program'),
				 'view_item' 	=> __('View Program'),
				'add_new_item'	=>	__( 'Add Program')

			),
			'public' => true,
			'menu_position' => 10,
			'menu_icon' => admin_url('images/generic.png'),
			'show_ui' => true,
			'capability_type' => 'post',
			'rewrite' => array( 'slug' => 'program', 'with_front' => false ),
			'taxonomies' => array( 'Programs '),
			'supports' => array(
			 'title',
	  'editor',
	  'excerpt',
	  'revisions',
	  'thumbnail',
	  'custom-fields',
	  'author',
	  )
		)
	);
  
  
}	




