<?php
Class DS_Quiz_Model{
	public function update_quiz(DS_Quiz_SetGet $quiz_obj){
		global $wpdb;
		$table	=	$wpdb->prefix.'quiz';
		$db_transaction_flag	=	true;
		$data	=	array( 
						'quiz_title'				=>	$quiz_obj->getQuiz_title(),
						'quiz_keyword'				=>	$quiz_obj->getQuiz_keyword(), 
						'quiz_alternate_keyword' 	=>	$quiz_obj->getQuiz_alternate_keyword(), 
						'quiz_response'				=>	$quiz_obj->getQuiz_response(), 
						'quiz_start_date'			=>	$quiz_obj->getQuiz_start_date(), 
						'quiz_end_date'				=>	$quiz_obj->getQuiz_end_date(), 
						'quiz_description'			=>	$quiz_obj->getQuiz_description(), 
						'quiz_active'				=>	$quiz_obj->getQuiz_active(), 
					);
					
					
		//$wpdb->query('START TRANSACTION');
		 			
		if($quiz_obj->getQuiz_id()){
			$quiz_id	=	$quiz_obj->getQuiz_id();
			$where	=	array('quiz_id'	=> $quiz_id);
			$update_flag	=	$wpdb->update( $table,  $data , $where);
			if($update_flag	=== false){
				$db_transaction_flag	=	$quiz_id	=	false;			
			}
		}else{
			$insert_flag	=	$wpdb->insert(	$table,	$data	);
			if($insert_flag){
				$quiz_id	=	$wpdb->insert_id;	
			}else{
				$db_transaction_flag	=	false;
			}
			
		}
		if($quiz_id && $db_transaction_flag){
			$question_answer_json	=	$quiz_obj->getQuiz_question_answer_json();
			if($question_answer_json){
				$question_answer_list	= json_decode (stripslashes($question_answer_json));
				
				foreach($question_answer_list as $question_answer){
					$question_answer_obj = new DS_Quiz_Question_SetGet();
					
					
					$quiz_question_quiz_id		=	$quiz_id;
					$quiz_question_id			=	$question_answer->quiz_question_id;
					$quiz_question_title		=	$question_answer->quiz_question_title;
					$quiz_question_keyword		=	$question_answer->quiz_question_keyword;
					$quiz_question_status		=	$question_answer->quiz_question_status;
					$quiz_answer_json			=	$question_answer->quiz_answer_json;
					
					
					$question_answer_obj->setQuiz_question_quiz_id($quiz_question_quiz_id); 
					$question_answer_obj->setQuiz_question_title($quiz_question_title);
					$question_answer_obj->setQuiz_question_keyword($quiz_question_keyword);
					
					if($quiz_question_id){
						$question_answer_obj->setQuiz_question_id($quiz_question_id);	
					}
					if($quiz_question_status != ''){
						$question_answer_obj->setQuiz_question_status($quiz_question_status);
					}
				
					$question_id	=	$this->update_quiz_question($question_answer_obj);
					if($question_id && $quiz_answer_json){
						foreach($quiz_answer_json as $answer_list){
							$answer_obj = new DS_Quiz_Answer_SetGet();
							
							$quiz_answer_quiz_question_id	=	$question_id;
							$quiz_answer_id					=	$answer_list->quiz_answer_id;
							$quiz_answer_title				=	$answer_list->quiz_answer_title;
							
							$quiz_answer_correct_answer		=	$answer_list->quiz_answer_correct_answer;
							$quiz_answer_status				=	$answer_list->quiz_answer_status;
							
							$answer_obj->setQuiz_answer_id($quiz_answer_id);
							$answer_obj->setQuiz_answer_quiz_question_id($quiz_answer_quiz_question_id);
							$answer_obj->setQuiz_answer_title($quiz_answer_title);
							$answer_obj->setQuiz_suggested_answers($answer_list->quiz_suggested_answers);
							$answer_obj->setQuiz_answer_correct_answer($quiz_answer_correct_answer);
							$answer_obj->setQuiz_answer_status($quiz_answer_status);
							
							$answer_id	=	$this->update_quiz_answer($answer_obj);
							if($answer_id === false){
								$db_transaction_flag	=	false;
								break;
							}
						}
					}
					if($question_id === false){
						$db_transaction_flag	=	false;
						break;
					}
				}
				//wp_update_quiz_prize($prize);
			}
		}else{
			$db_transaction_flag	=	false;
		}
		if($db_transaction_flag){
			//$wpdb->query('COMMIT');		
		}else{
			//$wpdb->query('ROLLBACK');
			$quiz_id	=	false;
		}
		return $quiz_id;
	}
	public function update_quiz_question(DS_Quiz_Question_SetGet $question_obj){
		global $wpdb;
		$table	=	$wpdb->prefix.'quiz_question';
		
		$data	=	array( 
						'quiz_question_quiz_id' 	=> $question_obj->getQuiz_question_quiz_id(), 
						'quiz_question_title' 		=> $question_obj->getQuiz_question_title(),
						'quiz_question_keyword' 		=> $question_obj->getQuiz_question_keyword(), 
						
					);
		if($question_obj->getQuiz_question_status() == 0 && $question_obj->getQuiz_question_id()){
			$question_id	=	$question_obj->getQuiz_question_id();
			$where		=	array('quiz_question_id'	=> $question_id);
			$question_delete_return	=	$wpdb->delete( $table,  $where);
			if($question_delete_return === false){
				$question_id	=	false;
			}
		}else if($question_obj->getQuiz_question_id()){
			$question_id	=	$question_obj->getQuiz_question_id();
			$where		=	array('quiz_question_id'	=> $question_id);
			
			$question_update_return	=	$wpdb->update( $table,  $data , $where);
			if($question_update_return === false){
				$question_id	=	false;
			}
		}else{
			$question_id	=	$wpdb->insert( $table,  $data);
			if($question_id) $question_id	=	$wpdb->insert_id;
		}
		
		return $question_id;
		
	}
	public function update_quiz_answer(DS_Quiz_Answer_SetGet $answer_obj){
		global $wpdb;
		$table	=	$wpdb->prefix.'quiz_answer';
		$data	=	array( 
						'quiz_answer_quiz_question_id' 	=> $answer_obj->getQuiz_answer_quiz_question_id(), 
						'quiz_answer_title' 			=> $answer_obj->getQuiz_answer_title(), 
						'quiz_suggested_answers' 			=> $answer_obj->getQuiz_suggested_answers(), 
						'quiz_answer_correct_answer' 	=> $answer_obj->getQuiz_answer_correct_answer(), 
					);
		if($answer_obj->getQuiz_answer_status() == 0 && $answer_obj->getQuiz_answer_id()){
			$answer_id	=	$answer_obj->getQuiz_answer_id();
			$where		=	array('quiz_answer_id'	=> $answer_id);
			$answer_id	=	$wpdb->delete( $table,  $where);
		}else if($answer_obj->getQuiz_answer_id()){
			$answer_id	=	$answer_obj->getQuiz_answer_id();
			$where		=	array('quiz_answer_id'	=> $answer_id);
			$answer_id	=	$wpdb->update( $table,  $data , $where);
		}else{
			$answer_id	=	$wpdb->insert( $table,  $data);
		}
		return $answer_id;
	}
	public function get_quiz(){
		global $wpdb;
		$quiz_list_arr	=	array();
		$table	=	$wpdb->prefix.'quiz';
		
		$quiz_list = $wpdb->get_results( 
			"SELECT quiz_id, quiz_title, quiz_start_date, quiz_end_date
			FROM $table
			WHERE quiz_status = 1 ORDER BY quiz_id desc"	);
		if($quiz_list){
			foreach ($quiz_list as $quiz){
				$quiz_id						=	$quiz->quiz_id;
				$quiz_title						=	$quiz->quiz_title;
				$quiz_end_date					=	$quiz->quiz_end_date;
				$quiz_start_date				=	$quiz->quiz_start_date;
				$quiz_status					=	$quiz->quiz_status;
				
				$quiz_obj	=	new DS_Quiz_SetGet();
				$quiz_obj->setQuiz_id			($quiz_id);
				$quiz_obj->setQuiz_title		($quiz_title);
				$quiz_obj->setQuiz_start_date	($quiz_start_date);
				$quiz_obj->setQuiz_end_date		($quiz_end_date);
				$quiz_obj->setQuiz_status		($quiz_status);
				$quiz_list_arr[]	=	$quiz_obj;
			}
		}
		return $quiz_list_arr;
	}
	public function get_quiz_details_by_id(DS_Quiz_SetGet $quiz){
		if($quiz->getQuiz_id()){
			$quiz_id	=	$quiz->getQuiz_id();
			$quiz_obj	= false;
			global $wpdb;
			$table	=	$wpdb->prefix.'quiz';
			$quiz_list_arr	=	array();
			$quiz = $wpdb->get_row( 
				"SELECT 
				quiz_id,
				quiz_title, 
				quiz_keyword, 
				quiz_alternate_keyword, 
				quiz_response, 
				quiz_start_date, 
				quiz_end_date, 
				quiz_description, 
				quiz_active
				FROM $table
				WHERE quiz_id = $quiz_id and quiz_status = 1 "	);
			
			if($quiz){
				
					$quiz_id						=	$quiz->quiz_id;
					$quiz_title						=	$quiz->quiz_title;
					$quiz_keyword					=	$quiz->quiz_keyword;
					$quiz_alternate_keyword			=	$quiz->quiz_alternate_keyword;
					$quiz_response					=	$quiz->quiz_response;
					$quiz_description				=	$quiz->quiz_description;
					$quiz_active					=	$quiz->quiz_active;
					$quiz_end_date					=	$quiz->quiz_end_date;
					$quiz_start_date				=	$quiz->quiz_start_date;
					
					$quiz_obj	=	new DS_Quiz_SetGet();
					$quiz_obj->setQuiz_id					($quiz_id);
					$quiz_obj->setQuiz_title				($quiz_title);
					$quiz_obj->setQuiz_keyword				($quiz_keyword);
					$quiz_obj->setQuiz_alternate_keyword	($quiz_alternate_keyword);
					$quiz_obj->setQuiz_response				($quiz_response);
					$quiz_obj->setQuiz_description			($quiz_description);
					$quiz_obj->setQuiz_active				($quiz_active);
					$quiz_obj->setQuiz_start_date			($quiz_start_date);
					$quiz_obj->setQuiz_end_date				($quiz_end_date);
					
					$quiz_question_obj	=	new DS_Quiz_Question_SetGet();
					$quiz_question_obj->setQuiz_question_quiz_id($quiz_id);
					$quiz_question_answer_obj	=	$this->get_quiz_question_answers_by_quiz_id($quiz_question_obj);
					if($quiz_question_answer_obj){
						$quiz_obj->setQuiz_question_answer_obj($quiz_question_answer_obj);
					}
					
				
			}
			return $quiz_obj;
			
		}else{
			return false;
		}
	}
	public function get_quiz_question_answers_by_quiz_id(DS_Quiz_Question_SetGet $question_obj){
		if($question_obj->getQuiz_question_quiz_id()){
			$quiz_id	=	$question_obj->getQuiz_question_quiz_id();
			$question_arr	= false;
			global $wpdb;
			$table	=	$wpdb->prefix.'quiz_question';
			$question_list_arr	=	array();
			$question_rquery = $wpdb->get_results( 
				"SELECT 
				quiz_question_id, 
				quiz_question_title,
				quiz_question_keyword
				FROM $table
				WHERE quiz_question_quiz_id = $quiz_id and quiz_question_status = 1 "	);
			if($question_rquery){
				$question_arr	=	array();
				foreach($question_rquery as $question_row){
					$quiz_question_id		=	$question_row->quiz_question_id;
					$quiz_question_title	=	$question_row->quiz_question_title;
					
					$question_obj	= new DS_Quiz_Question_SetGet();
					$question_obj->setQuiz_question_id($quiz_question_id);
					$question_obj->setQuiz_question_title($quiz_question_title);
					$question_obj->setQuiz_question_keyword($question_row->quiz_question_keyword);
					$answer_obj	=	new DS_Quiz_Answer_SetGet();
					$answer_obj->setQuiz_answer_quiz_question_id($quiz_question_id);
					$answer_arr	=	$this->get_quiz_answers_by_question_id($answer_obj);
					
					
					$question_obj->setQuiz_answer_obj($answer_arr);
					
					$question_arr[]	=	$question_obj;
				}
				return $question_arr;
			}
		}else{
			return false;
		}
	}
	public function get_quiz_answers_by_question_id(DS_Quiz_Answer_SetGet $answer_obj){
		if($answer_obj->getQuiz_answer_quiz_question_id()){
			$quiz_question_id	=	$answer_obj->getQuiz_answer_quiz_question_id();
			$answer_arr	= false;
			global $wpdb;
			$table	=	$wpdb->prefix.'quiz_answer';
			$answer_list_arr	=	array();
			$answer_rquery = $wpdb->get_results( 
				"SELECT 
					quiz_answer_id, 
					quiz_answer_title, 
					quiz_suggested_answers,
					quiz_answer_correct_answer
				FROM $table
				WHERE quiz_answer_quiz_question_id = $quiz_question_id and quiz_answer_status = 1 "	);
			
			if($answer_rquery){
				$answer_arr	=	array();
				foreach($answer_rquery as $answer_row){
					$quiz_answer_id				=	$answer_row->quiz_answer_id;
					$quiz_answer_title			=	$answer_row->quiz_answer_title;
					$quiz_answer_correct_answer	=	$answer_row->quiz_answer_correct_answer;
					
					$answer_obj	= new DS_Quiz_Answer_SetGet();
					$answer_obj->setQuiz_answer_id($quiz_answer_id);
					$answer_obj->setQuiz_answer_title($quiz_answer_title);
					$answer_obj->setQuiz_suggested_answers($answer_row->quiz_suggested_answers);
					$answer_obj->setQuiz_answer_correct_answer($quiz_answer_correct_answer);
					$answer_arr[]	=	$answer_obj;
				}
			}
			return $answer_arr;
		}else{
			return false;
		}
	}
	public function delete(DS_Quiz_SetGet $quiz_obj){
		if($quiz_obj->getQuiz_id()){
			global $wpdb;
			$table	=	$wpdb->prefix.'quiz';
			$quiz_id	=	$quiz_obj->getQuiz_id();
			$data	=	array( 
						'quiz_status' 	=> 0 
					);
			$where		=	array('quiz_id'	=> $quiz_id);
			$quiz_update_return		=	$wpdb->update( $table,  $data , $where);
			return $quiz_update_return;
		}else{
			return false;
		}
	}
}