<?php 
Class DS_Role_Model{
	function __construct(){
		 global $cats_by_parent;
	}
	public function add_new_role($role_name){
		
		if (!$role_name) {
	        throw new Exception('New role details not recevied.');
	    }
	    
		$result = add_role(
		    sanitize_title($role_name),
		    __( $role_name ),
		    array(
		        'read'         => true,  // true allows this capability
		        'edit_posts'   => true,
		        'delete_posts' => false, // Use false to explicitly deny
		    )
		);
		if ( null !== $result ) {
		    echo 'Yay! New role created!';
		}
		else {
		    echo 'Oh... the basic_contributor role already exists.';
		}
	}
	public function duplicate_new_role($new_role_name,$duplicate_role_slug){
		
		
		$result = add_role(
		    sanitize_title($new_role_name),
		    __( $new_role_name ),
		    array(
		        'read'         => true,  // true allows this capability
		        'edit_posts'   => true,
		        'delete_posts' => false, // Use false to explicitly deny
		    )
		);
		$duplicate_role_details	=	get_option($duplicate_role_slug.'_role_cap');
		$result_cap	=	update_option($new_role_name.'_role_cap', $duplicate_role_details);
		
		if ( null !== $result ) {
		    echo 'Yay! New role created!';
		}
		else {
		    echo 'Oh... the basic_contributor role already exists.';
		}
	}
	
	public function get_role_capabilties_by_role_name_ajax(DS_Role_SetGet $role_setget){
		$role_name	=	$role_setget->getRole_name();
	if($role_name){
			$args = array(
				'type'                     => 'post',
				'child_of'                 => 0,
				'parent'                   => '',
				'orderby'                  => 'name',
				'order'                    => 'ASC',
				'hide_empty'               => 0,
				'hierarchical'             => 0,
				'exclude'                  => '',
				'include'                  => '',
				'number'                   => '',
				'taxonomy'                 => 'grid_role_capability',
				'pad_counts'               => false 
			
			); 
		
			$categories = get_categories( $args );
		
			// First index all categories by parent id, for easy lookup later
			$cats_by_parent = array();
			foreach ($categories as $cat)
			{
			  $parent_id = $cat->category_parent;
			  if (!array_key_exists($parent_id, $cats_by_parent)) 
			  {
			    $cats_by_parent[$parent_id] = array();
			  }
			  $cats_by_parent[$parent_id][] = $cat;
			}
			
			// Then build a hierarchical tree
			$cat_tree = array();
			
			
			$this->add_cats_to_bag($cat_tree['cap'], $cats_by_parent[0]);
			
			
			
			$role_cap_vals	=	get_option( $role_name.'_role_cap' );
			$cat_tree['val']	=	json_decode(unserialize(($role_cap_vals)));	
			
			return json_encode($cat_tree,JSON_FORCE_OBJECT);							
		}else{
			return false;
		}
	}
	public function add_cats_to_bag(&$child_bag, &$children)
			{
			   global $cats_by_parent;
			   foreach ($children as $child_cat) 
			   {
			     $child_id = $child_cat->cat_ID;
			     if (array_key_exists($child_id, $cats_by_parent)) 
			     {
			        $child_cat->children = array();
			        $this->add_cats_to_bag($child_cat->children, $cats_by_parent[$child_id]);
			     }
			     $child_bag[$child_id] = $child_cat;
			   }
	}
}
?>